"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var React = tslib_1.__importStar(require("react"));
var react_native_web_1 = require("react-native-web");
var PickerMixin_1 = tslib_1.__importDefault(require("./PickerMixin"));
var MutiPicker_1 = tslib_1.__importDefault(require("./MutiPicker"));
var styles = {
    picker: {
        position: 'relative',
        overflow: 'hidden',
        width: '100%',
        flex: 1,
        height: '238px',
        display: 'flex',
        justifyContent: 'center',
    },
    pickerItem: {
        fontSize: '16px',
        height: '34px',
        lineHeight: '34px',
        margin: '0 20px',
        whiteSpace: 'nowrap',
        position: 'relative',
        overflow: 'hidden',
        textOverflow: 'ellipsis',
        color: '#9b9b9b',
        // width: '100%',
        backgroundColor: 'transparent',
        boxSizing: 'border-box',
        alignSelf: 'center',
        display: 'flex',
        justifyContent: 'center',
    },
    indicator: {
        margin: '0 auto',
        boxSizing: 'border-box',
        width: '100%',
        height: '34px',
        position: 'absolute',
        left: 0,
        top: '102px',
        zIndex: 3,
        borderTop: '1PX solid #ddd',
        borderBottom: '1PX solid #ddd',
    },
    mask: {
        position: 'absolute',
        left: 0,
        top: 0,
        height: '100%',
        margin: '0 auto',
        width: '100%',
        zIndex: 3,
        backgroundImage: 'linear-gradient(to bottom, rgba(255, 255, 255, 0.95), rgba(255, 255, 255, 0.6)), linear-gradient(to top, rgba(255, 255, 255, 0.95), rgba(255, 255, 255, 0.6))',
        backgroundPosition: 'top, bottom',
        backgroundSize: '100% 204px',
        backgroundRepeat: 'no-repeat',
    },
};
var Picker = /** @class */ (function (_super) {
    tslib_1.__extends(Picker, _super);
    function Picker(props) {
        var _this = _super.call(this, props) || this;
        _this.scrollHanders = (function () {
            var scrollY = -1;
            var lastY = 0;
            var startY = 0;
            var scrollDisabled = false;
            var isMoving = false;
            var setTransform = function (nodeStyle, value) {
                nodeStyle.transform = value;
                nodeStyle.webkitTransform = value;
            };
            var setTransition = function (nodeStyle, value) {
                nodeStyle.transition = value;
                nodeStyle.webkitTransition = value;
            };
            var scrollTo = function (_x, y, time) {
                if (time === void 0) { time = 0.3; }
                if (scrollY !== y) {
                    scrollY = y;
                    if (time && !_this.props.noAnimate) {
                        setTransition(_this.contentRef.style, "cubic-bezier(0,0,0.2,1.15) " + time + "s");
                    }
                    setTransform(_this.contentRef.style, "translate3d(0," + -y + "px,0)");
                    setTimeout(function () {
                        _this.scrollingComplete();
                        if (_this.contentRef) {
                            setTransition(_this.contentRef.style, '');
                        }
                    }, +time * 1000);
                }
            };
            var Velocity = (function (minInterval, maxInterval) {
                if (minInterval === void 0) { minInterval = 30; }
                if (maxInterval === void 0) { maxInterval = 100; }
                var _time = 0;
                var _y = 0;
                var _velocity = 0;
                var recorder = {
                    record: function (y) {
                        var now = +new Date();
                        _velocity = (y - _y) / (now - _time);
                        if (now - _time >= minInterval) {
                            _velocity = now - _time <= maxInterval ? _velocity : 0;
                            _y = y;
                            _time = now;
                        }
                    },
                    getVelocity: function (y) {
                        if (y !== _y) {
                            recorder.record(y);
                        }
                        return _velocity;
                    },
                };
                return recorder;
            })();
            var onFinish = function () {
                isMoving = false;
                var targetY = scrollY;
                var height = (_this.props.children.length - 1) * _this.itemHeight;
                var time = 0.3;
                var velocity = Velocity.getVelocity(targetY) * 4;
                if (velocity) {
                    targetY = velocity * 40 + targetY;
                    time = Math.abs(velocity) * 0.1;
                }
                if (targetY % _this.itemHeight !== 0) {
                    targetY = Math.round(targetY / _this.itemHeight) * _this.itemHeight;
                }
                if (targetY < 0) {
                    targetY = 0;
                }
                else if (targetY > height) {
                    targetY = height;
                }
                scrollTo(0, targetY, time < 0.3 ? 0.3 : time);
                _this.onScrollChange();
            };
            var onStart = function (y) {
                if (scrollDisabled) {
                    return;
                }
                isMoving = true;
                startY = y;
                lastY = scrollY;
            };
            var onMove = function (y) {
                if (scrollDisabled || !isMoving) {
                    return;
                }
                scrollY = lastY - y + startY;
                Velocity.record(scrollY);
                _this.onScrollChange();
                setTransform(_this.contentRef.style, "translate3d(0," + -scrollY + "px,0)");
            };
            return {
                touchstart: function (evt) { return onStart(evt.touches[0].pageY); },
                mousedown: function (evt) { return onStart(evt.pageY); },
                touchmove: function (evt) {
                    evt.preventDefault();
                    onMove(evt.touches[0].pageY);
                },
                mousemove: function (evt) {
                    evt.preventDefault();
                    onMove(evt.pageY);
                },
                touchend: function () { return onFinish(); },
                touchcancel: function () { return onFinish(); },
                mouseup: function () { return onFinish(); },
                getValue: function () {
                    return scrollY;
                },
                scrollTo: scrollTo,
                setDisabled: function (disabled) {
                    if (disabled === void 0) { disabled = false; }
                    scrollDisabled = disabled;
                },
            };
        })();
        _this.scrollTo = function (top) {
            _this.scrollHanders.scrollTo(0, top);
        };
        _this.scrollToWithoutAnimation = function (top) {
            _this.scrollHanders.scrollTo(0, top, 0);
        };
        _this.fireValueChange = function (selectedValue) {
            if (selectedValue !== _this.state.selectedValue) {
                if (!('selectedValue' in _this.props)) {
                    _this.setState({
                        selectedValue: selectedValue,
                    });
                }
                if (_this.props.onValueChange) {
                    _this.props.onValueChange(selectedValue);
                }
            }
        };
        _this.onScrollChange = function () {
            var top = _this.scrollHanders.getValue();
            if (top >= 0) {
                var children = React.Children.toArray(_this.props.children);
                var index = _this.props.computeChildIndex(top, _this.itemHeight, children.length);
                if (_this.scrollValue !== index) {
                    _this.scrollValue = index;
                    var child = children[index];
                    if (child && _this.props.onScrollChange) {
                        _this.props.onScrollChange(child.props.value);
                    }
                    else if (!child && console.warn) {
                        console.warn('child not found', children, index);
                    }
                }
            }
        };
        _this.scrollingComplete = function () {
            var top = _this.scrollHanders.getValue();
            if (top >= 0) {
                _this.props.doScrollingComplete(top, _this.itemHeight, _this.fireValueChange);
            }
        };
        var selectedValueState;
        var _a = _this.props, selectedValue = _a.selectedValue, defaultSelectedValue = _a.defaultSelectedValue;
        if (selectedValue !== undefined) {
            selectedValueState = selectedValue;
        }
        else if (defaultSelectedValue !== undefined) {
            selectedValueState = defaultSelectedValue;
        }
        else {
            var children = React.Children.toArray(_this.props.children);
            selectedValueState = children && children[0] && children[0].props.value;
        }
        _this.state = {
            selectedValue: selectedValueState,
        };
        return _this;
    }
    Picker.prototype.componentDidMount = function () {
        var _this = this;
        var _a = this, contentRef = _a.contentRef, indicatorRef = _a.indicatorRef, maskRef = _a.maskRef, rootRef = _a.rootRef;
        setTimeout(function () {
            var rootHeight = rootRef.getBoundingClientRect().height;
            // https://github.com/react-component/m-picker/issues/18
            var itemHeight = (_this.itemHeight = indicatorRef.getBoundingClientRect().height);
            var num = Math.floor(rootHeight / itemHeight);
            if (num % 2 === 0) {
                num--;
            }
            num--;
            num /= 2;
            contentRef.style.padding = itemHeight * num + "px 0";
            indicatorRef.style.top = itemHeight * num + "px";
            maskRef.style.backgroundSize = "100% " + itemHeight * num + "px";
            _this.scrollHanders.setDisabled(_this.props.disabled);
            _this.props.select(_this.state.selectedValue, _this.itemHeight, _this.scrollTo);
            var passiveSupported = _this.passiveSupported();
            var willPreventDefault = passiveSupported ? { passive: false } : false;
            var willNotPreventDefault = passiveSupported ? { passive: true } : false;
            Object.keys(_this.scrollHanders).forEach(function (key) {
                if (key.indexOf('touch') === 0 || key.indexOf('mouse') === 0) {
                    var pd = key.indexOf('move') >= 0 ? willPreventDefault : willNotPreventDefault;
                    rootRef.addEventListener(key, _this.scrollHanders[key], pd);
                }
            });
        }, 0);
    };
    Picker.prototype.componentWillUnmount = function () {
        var _this = this;
        Object.keys(this.scrollHanders).forEach(function (key) {
            if (key.indexOf('touch') === 0 || key.indexOf('mouse') === 0) {
                _this.rootRef.removeEventListener(key, _this.scrollHanders[key]);
            }
        });
    };
    Picker.prototype.passiveSupported = function () {
        var passiveSupported = false;
        try {
            var options = Object.defineProperty({}, 'passive', {
                get: function () {
                    passiveSupported = true;
                },
            });
            window.addEventListener('test', null, options);
        }
        catch (err) { }
        return passiveSupported;
    };
    Picker.prototype.componentWillReceiveProps = function (nextProps) {
        var _this = this;
        if ('selectedValue' in nextProps) {
            if (this.state.selectedValue !== nextProps.selectedValue) {
                this.setState({
                    selectedValue: nextProps.selectedValue,
                }, function () {
                    _this.props.select(nextProps.selectedValue, _this.itemHeight, nextProps.noAnimate ? _this.scrollToWithoutAnimation : _this.scrollTo);
                });
            }
        }
        this.scrollHanders.setDisabled(nextProps.disabled);
    };
    Picker.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return (this.state.selectedValue !== nextState.selectedValue ||
            this.props.children !== nextProps.children);
    };
    Picker.prototype.componentDidUpdate = function () {
        this.props.select(this.state.selectedValue, this.itemHeight, this.scrollToWithoutAnimation);
    };
    Picker.prototype.getValue = function () {
        if ('selectedValue' in this.props) {
            return this.props.selectedValue;
        }
        var children = React.Children.toArray(this.props.children);
        return children && children[0] && children[0].props.value;
    };
    Picker.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var prefixCls = props.prefixCls, itemStyle = props.itemStyle, children = props.children, rest = tslib_1.__rest(props, ["prefixCls", "itemStyle", "children"]);
        var selectedValue = this.state.selectedValue;
        var itemClassName = prefixCls + "-item";
        var selectedItemClassName = itemClassName + " " + prefixCls + "-item-selected";
        var map = function (item) {
            var _a = item.props, _b = _a.className, className = _b === void 0 ? '' : _b, style = _a.style, value = _a.value, label = _a.label;
            var _c = react_native_web_1.StyleSheet.flatten(itemStyle).color, color = _c === void 0 ? '#333' : _c;
            var textStyle = react_native_web_1.StyleSheet.flatten([styles.pickerItem, itemStyle, { color: color }]);
            return (React.createElement("div", { className: (selectedValue === value ? selectedItemClassName : itemClassName) + " " + className, style: tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, styles.pickerItem), style), textStyle), key: value }, label));
        };
        // compatibility for preact
        var items = React.Children ? React.Children.map(children, map) : [].concat(children).map(map);
        return (React.createElement(MutiPicker_1.default, tslib_1.__assign({}, rest),
            React.createElement("div", { style: styles.picker, ref: function (el) { return (_this.rootRef = el); } },
                React.createElement("div", { style: styles.mask, ref: function (el) { return (_this.maskRef = el); } }),
                React.createElement("div", { ref: function (el) { return (_this.indicatorRef = el); }, style: styles.indicator }),
                React.createElement("div", { ref: function (el) { return (_this.contentRef = el); } }, items))));
    };
    Picker.defaultProps = {
        prefixCls: 'rmc-picker',
    };
    return Picker;
}(React.Component));
exports.default = PickerMixin_1.default(Picker);
